--------------------------------------------------------------------------------
-- Company: OHO-ELEKTRONIK
-- Engineer: <M.Randelzhofer>
--
-- Create Date: 3.11.2005
-- Design Name: GOP_XC3S200_BLINK
-- GOP_XC3S200 BLINK TEST
--------------------------------------------------------------------------------




library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity ucf_xc3s200_blink is
Port (	osc : in std_logic ;
		scs,soe,swr,fcs : inout std_logic ;
		sa: inout std_logic_vector (18 downto 0) ;
		sd: inout std_logic_vector (7 downto 0) ;
		tp2: inout std_logic ;
		tp3: inout std_logic ;
		tp4: inout std_logic ;
		tp5: inout std_logic ;
		tp6: inout std_logic ;
		tp7: inout std_logic ;
		tp8: inout std_logic ;		
		pin1: inout std_logic ;
		pin2: inout std_logic ;
		pin3: inout std_logic ;
		pin4: inout std_logic ;
		pin5: inout std_logic ;
		pin6: inout std_logic ;
		pin7: inout std_logic ;
		pin8: inout std_logic ;
		pin9: inout std_logic ;
		pin10: inout std_logic ;
		pin11: inout std_logic ;
		pin13: inout std_logic ;
		pin14: inout std_logic ;
		pin15: inout std_logic ;
		pin16: inout std_logic ;
		pin17: inout std_logic ;
		pin18: inout std_logic ;
		pin19: inout std_logic ;
		pin20: inout std_logic ;
		pin21: inout std_logic ;
		pin22: inout std_logic ;
		pin23: inout std_logic ;
		sw1,sw2 : in std_logic) ;
end ucf_xc3s200_blink ;

architecture behavioral of ucf_xc3s200_blink is

component BUFG
 port (I:in STD_LOGIC; O:out STD_LOGIC) ;
end component;

signal sw1q,sw2q:		STD_LOGIC ;
signal clock,down,inv:	STD_LOGIC ;

signal uled:			STD_LOGIC_VECTOR (7 downto 0) ;
signal clkdiv:			STD_LOGIC_VECTOR (24 downto 0) ;


begin
CLOCKIN:	BUFG port map (I => osc, O => clock) ;

sa(11) <= uled(0) ;
sa(12) <= uled(1) ;
sa(13) <= uled(2) ;
sa(14) <= uled(3) ;
sa(15) <= uled(4) ;
sa(16) <= uled(5) ;
sa(17) <= uled(6) ;
sa(18) <= uled(7) ;


-- clock divide by counting up or down; tp2 as reset
CLOCK_DIVIDE: process(clock,tp2)
begin
  if (tp2 = '0') then
	down <= '0' ;
	inv <= '0' ;
  elsif (clock'event and clock ='1') then
	if (down = '0') then
		clkdiv <= clkdiv + 1 ;
	else
		clkdiv <= clkdiv - 1 ;
	end if ;
	if (sw1q = '0') and (sw2q = '0') then
		inv <= not inv ;
	elsif (sw1q = '0') then
		down <= '1' ;
	elsif (sw2q = '0') then
		down <= '0' ;
	end if ;
  end if ;
end process ;

-- IO registers
IO_REGS: process(clock,tp2)
begin
  if (tp2 = '0') then
	sw1q <= '1' ;
	sw2q <= '1' ;
  elsif (clock'event and clock ='1') then
	sw1q <= sw1 ;
	sw2q <= sw2 ;
	uled(0) <= (not clkdiv(24) and not clkdiv(23) and not clkdiv(22)) xor inv ;
	uled(1) <= (not clkdiv(24) and not clkdiv(23) and     clkdiv(22)) xor inv ;
	uled(2) <= (not clkdiv(24) and     clkdiv(23) and not clkdiv(22)) xor inv ;
	uled(3) <= (not clkdiv(24) and     clkdiv(23) and     clkdiv(22)) xor inv ;
	uled(4) <= (    clkdiv(24) and not clkdiv(23) and not clkdiv(22)) xor inv ;
	uled(5) <= (    clkdiv(24) and not clkdiv(23) and     clkdiv(22)) xor inv ;
	uled(6) <= (    clkdiv(24) and     clkdiv(23) and not clkdiv(22)) xor inv ;
	uled(7) <= (    clkdiv(24) and     clkdiv(23) and     clkdiv(22)) xor inv ;
  end if ;
end process ;






end behavioral ;
